<?php
/**
 * Created by PhpStorm.
 * User: tatu
 * Date: 6/23/20
 * Time: 12:10 AM
 */

use App\Models\AppSession;

if(!function_exists('get_current_session')) {
    function get_current_session(){
        return AppSession::where('session_key', request()->cookie('sessionKey'))->first();
    }
}

if(!function_exists('friendly_date_time')) {
    function friendly_date_time($value, $includeTime = true, $default = '-') {
        if(!$value || empty($value)) return $default;
        try {
            $result = strtotime($value);
            $result = date("jS M o" . ($includeTime ? ", H:i" : ""), $result);
            return $result;
        }
        catch (Exception $e) {
            return $value;
        }
    }
}

if(!function_exists('friendly_time')) {
    function friendly_time($value, $default = '-') {
        if(!$value || empty($value)) return $default;
        try {
            $result = strtotime($value);
            $result = date("H:i", $result);
            return $result;
        }
        catch (Exception $e) {
            return $value;
        }
    }
}

if(!function_exists('friendly_month')) {
    function friendly_month($value) {
        if(!$value || empty($value)) return "-";
        try {
            $result = strtotime($value);
            $result = date("M o", $result);
            return $result;
        }
        catch (Exception $e) {
            return $value;
        }
    }
}

if(!function_exists('time_in_hrminsec')) {
    function time_in_hrminsec($value, $default = '-') {
        if(!$value || empty($value)) return $default;
        $value = intval($value);
        $minutes = intval($value / 60);
        $seconds = $value % 60;
        $hours = 0;
        if($minutes >= 60) {
            $hours = intval($minutes / 60);
            $minutes = $minutes % 60;
        }
        $output = [];
        if($hours > 0) {
            $output[] = "{$hours}h";
        }
        if($minutes > 0) {
            $output[] = "{$minutes}m";
        }
        if($seconds > 0) {
            $output[] = "{$seconds}s";
        }
        return implode(" ", $output);
    }
}

if(!function_exists('sanitize_field_name')) {
    function sanitize_field_name($name) {
        $result = strtolower($name);
        return preg_replace("/[^0-9a-z]/i", "_", $result);
    }
}

if(!function_exists('renderNoteTemplates')) {

    function _renderNoteTemplate($template, $topLevel) {
        echo
            '<div class="note-template-item" ' .
                'template="' . (isset($template->template) ? $template->template : $template->text) . '" ' .
                'type="' . (isset($template->type) ? $template->type : "value") . '" ' .
                '>' .
            '<div class="note-template-text">';
        echo '<span class="label">' .
            '<input type="checkbox" />' .
            '<span>' . $template->text . '</span>' .
            '</span></div>';
        if(isset($template->children) && count($template->children)) {
            echo '<i class="fa fa-chevron-right has-children"></i>';
            echo '<div class="note-template-children">';
            foreach ($template->children as $t) {
                _renderNoteTemplate($t, false);
            }
            echo '</div>';
        }
        else if(isset($template->type) && $template->type === 'text') {
            echo '<i class="fa fa-chevron-right has-children"></i>';
            echo '<div class="note-template-children">';
            echo '<textarea class="form-control form-control-sm"></textarea>';
            echo '</div>';
        }
        echo '</div>';
    }

    function renderNoteTemplates($path) {
        $templates = json_decode(file_get_contents($path));
//        echo '<pre class="border my-3">';
//        print_r($templates);
//        echo '</pre>';
        echo '<div class="note-template-container">';
        echo '<div class="position-relative w-100">' .
                '<div class="note-template-output">' .
                    '<div class="font-weight-bold text-secondary">Result:</div>' .
                    '<div class="note-template-output-text"></div>' .
                '</div>' .
                '<div class="note-template-buttons d-flex align-items-center">' .
                    '<button class="btn btn-sm btn-default bg-white border text-primary border-primary note-template-apply-trigger">Apply</button>' .
                    '<button class="btn btn-sm btn-default bg-light border text-secondary border-secondary note-template-close-trigger">Close</button>' .
                '</div>' .
            '</div>';
        foreach ($templates as $template) {
            _renderNoteTemplate($template, true);
        }
        echo '</div>';
    }
}
